c     matrix manipulation routines
c
      SUBROUTINE ugrid(vector,npts,vmin,vmax)
#include "Implic.inc"
      INTEGER npts, ipts
      REAL vector, vmin, vmax, ripts1, rnpts1, dv
      DIMENSION vector(npts)
c
c     generate a uniform grid vector(j) from vmin to vmax
c
      if(npts.le.1)return
      rnpts1=npts-1
      dv=(vmax-vmin)/rnpts1
      do 1 ipts=1,npts
      ripts1=ipts-1
1     vector(ipts)=vmin+ripts1*dv
      return
      END

      SUBROUTINE ugridEXC(vector,npts,vmin,vmax,EXCLUDED)
#include "Implic.inc"
      INTEGER npts, ipts
      REAL    vector(npts), vmin, vmax, rnpts1, dv
      REAL 
     ^        EXCLUDED, vmaxPLUS, vminPLUS, vmaxMINU, vminMINU, v
      REAL       ZERO
      DATA       ZERO   /
     ^     CONST(0.0,0) /
c
c     generate a uniform grid vector(j) from vmin to vmax
c     excluding points with abs value .le. EXCLUDED
c
      if(npts .le. 1 .or. vmax .le. vmin ) return
      rnpts1=npts-1
      vmaxPLUS =  max ( abs(EXCLUDED) , vmax )
      vminPLUS =  max ( abs(EXCLUDED) , vmin )
      vmaxMINU =  min (-abs(EXCLUDED) , vmax )
      vminMINU =  min (-abs(EXCLUDED) , vmin )
      dv =       max ( (vmaxPLUS-vminPLUS) , ZERO) +
     ^           max ( (vmaxMINU-vminMINU) , ZERO)
c     dv =       max ( (vmaxPLUS-vminPLUS) , 0.0 ) +
c    ^           max ( (vmaxMINU-vminMINU) , 0.0 )
      dv=dv/rnpts1
      if (dv .le. ZERO) return
c
      v = vmin
      do 10 ipts=1,npts
      vector(ipts) = v
        v = v + dv
        if (abs(v) .lt. abs(EXCLUDED)) go to 20
 10   continue
      return
c
c     return for normal exit when the excluded zone is not an issue
c
 20   continue
      v = vmax
      do 30 ipts=npts,1,-1
      vector(ipts) = v
        v = v - dv
        if (abs(v) .lt. abs(EXCLUDED)) go to 40
 30   continue
 40   return
c
c     return for unusual exit when the positive used zone comes
c     after a negative used zone
c

      END
c
      SUBROUTINE mkdelv(n, delv, v)
#include "Implic.inc"
      INTEGER n, i
      REAL
     ^     delv(n), v(n)
      do 10 i = 2, n - 1
         delv(i) = 0.5 * (v(i + 1) - v(i - 1))
 10   continue
      delv(1) = delv(2)
      delv(n) = delv(n - 1)
      return
      END

      SUBROUTINE mkdvp(n, delv, v)
#include "Implic.inc"
      INTEGER n, i
      REAL
     ^     delv(n), v(n)
      do 10 i = 1, n - 1
         delv(i) = v(i + 1) - v(i)
 10   continue
      delv(n) = delv(n - 1)
      return
      END

      SUBROUTINE mkvinv(n, vto, vfrom)
#include "Implic.inc"
      INTEGER n, i
      REAL
     ^     vto(n), vfrom(n)
      do 10 i = 1, n
         vto(i) = CONST(1.,0) / vfrom(i)
 10   continue
      return
      END

      SUBROUTINE VecDmp(VecFr,VecTo,n,nsk)
#include "Implic.inc"
      INTEGER n, nsk, i
      REAL VecFr(nsk, n), VecTo(n)
      do 10 i=1,n
         VecTo(i) = VecFr(1, i)
 10   continue
      return
      END
c
c
      SUBROUTINE BrodCast(n, vec, scalar)
#include "Implic.inc"
      INTEGER n, i
      REAL vec(n), scalar
      do 10 i = 1, n
        vec(i) = scalar
 10   continue
      return
      END
c
c     matrix manipulation routines end here

